package com.blamejared.compat.botania.lexicon.pages;

import vazkii.botania.api.lexicon.LexiconPage;
import vazkii.botania.api.lexicon.LexiconEntry;
import java.util.List;
import vazkii.botania.common.lexicon.page.PageCraftingRecipe;
import net.minecraft.util.ResourceLocation;
import java.util.ArrayList;
import crafttweaker.CraftTweakerAPI;
import com.blamejared.compat.botania.BotaniaHelper;
import crafttweaker.IAction;

public class AddPageCrafting implements IAction
{
    private String name;
    private String entry;
    private int page_number;
    private String[] recipeNames;
    
    public AddPageCrafting(final String name, final String entry, final int page_number, final String[] recipeNames) {
        this.name = name;
        this.entry = entry;
        this.page_number = page_number;
        this.recipeNames = recipeNames;
    }
    
    public void apply() {
        final LexiconEntry lexiconEntry = BotaniaHelper.findEntry(this.entry);
        if (lexiconEntry == null) {
            CraftTweakerAPI.getLogger().logError("Cannot find lexicon entry " + this.entry);
            return;
        }
        if (this.page_number > lexiconEntry.pages.size()) {
            CraftTweakerAPI.getLogger().logError("Page Number " + this.page_number + " out of bounds for " + this.entry);
            return;
        }
        final List<ResourceLocation> recipes = new ArrayList<ResourceLocation>();
        for (final String s : this.recipeNames) {
            recipes.add(new ResourceLocation(s));
        }
        final LexiconPage page = (LexiconPage)new PageCraftingRecipe(this.name, (List)recipes);
        lexiconEntry.pages.add(this.page_number, page);
    }
    
    public String describe() {
        return "Adding Lexicon Page: " + this.name;
    }
}
